/*
** PȉAetsVF[_
*/
#include "GgSimpleShader.h"

// RXgN^
gg::GgSimpleShader::GgSimpleShader(
  const GLchar *vert,
  const GLchar *frag,
  const GLchar *pv,
  const GLchar *nv,
  const GLchar *mw,
  const GLchar *mc,
  const GLchar *mg,
  const GLchar *ldiff,
  const GLchar *lspec,
  const GLchar *lamb,
  const GLchar *lpos,
  const GLchar *kdiff,
  const GLchar *kspec,
  const GLchar *kamb,
  const GLchar *kshi
  )
  : GgShader(vert, frag)
{
  // f[^̏
  light = 0;
  material = 0;
  
  // attribute ϐ̏ꏊ̎擾
  pvLoc = glGetAttribLocation(getProgram(), pv);
  nvLoc = glGetAttribLocation(getProgram(), nv);

  // Wϊ uniform ϐ̏ꏊ̎擾
  mwLoc = glGetUniformLocation(getProgram(), mw);
  mcLoc = glGetUniformLocation(getProgram(), mc);
  mgLoc = glGetUniformLocation(getProgram(), mg);

  // p[^ uniform ϐ̏ꏊ̎擾
  ldiffLoc = glGetUniformLocation(getProgram(), ldiff);
  lspecLoc = glGetUniformLocation(getProgram(), lspec);
  lambLoc = glGetUniformLocation(getProgram(), lamb);
  lposLoc = glGetUniformLocation(getProgram(), lpos);

  // ގp[^ uniform ϐ̏ꏊ̎擾
  kdiffLoc = glGetUniformLocation(getProgram(), kdiff);
  kspecLoc = glGetUniformLocation(getProgram(), kspec);
  kambLoc = glGetUniformLocation(getProgram(), kamb);
  kshiLoc = glGetUniformLocation(getProgram(), kshi);
}

// VF[_vO̓Kp
void gg::GgSimpleShader::use(GgMatrix &projection, GgMatrix &modelview) const
{
  // vOIuWFNg̎w
  glUseProgram(getProgram());
  
  // ϊs̐ݒ
  glUniformMatrix4fv(mwLoc, 1, GL_FALSE, modelview.get());
  glUniformMatrix4fv(mcLoc, 1, GL_FALSE, (projection * modelview).get());
  glUniformMatrix4fv(mgLoc, 1, GL_FALSE, modelview.normal().get());
  
  // p[^̐ݒ
  glUniform4fv(ldiffLoc, 1, light->getDiffuse());
  glUniform4fv(lspecLoc, 1, light->getSpecular());
  glUniform4fv(lambLoc, 1, light->getAmbient());
  glUniform4fv(lposLoc, 1, light->getPosition());
  
  // ގp[^̐ݒ
  glUniform4fv(kdiffLoc, 1, material->getDiffuse());
  glUniform4fv(kspecLoc, 1, material->getSpecular());
  glUniform4fv(kambLoc, 1, material->getAmbient());
  glUniform1f(kshiLoc, material->getShininess());
}
