#version 120

// _
attribute vec4 pv;  // [JWn̒_̈ʒu
attribute vec4 nv;  // _̖@xNg

// ϊs
uniform mat4 mw;    // _Wnւ̕ϊs
uniform mat4 mc;    // NbsOWnւ̕ϊs
uniform mat4 mg;    // @xNg̕ϊs

// 
uniform vec4 ldiff; // gUˌ
uniform vec4 lspec; // ʔˌ
uniform vec4 lamb;  // 
uniform vec4 lpos;  // ʒu

// ގ
uniform vec4 kdiff; // gUˌW
uniform vec4 kspec; // ʔˌW
uniform vec4 kamb;  // ̔ˌW
uniform float kshi; // PW

// ˌx
varying vec4 iamb;  // ̔ˌx
varying vec4 idiff; // gUˌx
varying vec4 ispec; // ʔˌx

void main(void)
{
  vec4 p = mw * pv;
  vec3 n = normalize((mg * nv).xyz);
  vec3 l = normalize((p.w * lpos - lpos.w * p).xyz);
  vec3 h = normalize(l - normalize(p.xyz));

  iamb = kamb * lamb;
  idiff = max(dot(n, l), 0.0) * kdiff * ldiff;
  ispec = pow(max(dot(n, h), 0.0), kshi) * kspec * lspec;
  
  gl_Position = mc * pv;
}
